
basePaladinStrength = {                                  --Base Strength Table for Paladins
   ["Human"] = 179,
   ["Dwarf"] = 183,
   ["Draenei"] = 179,
   ["Tauren"] = 183,
   ["Blood Elf"] = 175
}
basePaladinStamina = {                                 --Base Stamina Table for Paladins
   ["Human"] = 169,
   ["Dwarf"] = 170,
   ["Draenei"] = 169,
   ["Tauren"] = 170,
   ["Blood Elf"] = 169
}

--[[baseWarriorStrength = {                                  --Base Warrior Strength Table
                    ["Human"] = 20,
                    ["Dwarf"] = 22,
                    ["Draenei"] = 21,
                    ["Gnome"] = 15,
                    ["Night Elf"] = 17,
                    ["Worgen"] = 23,
                    ["Pandaren"] = 20,
                    ["Orc"] = 23,
                    ["Troll"] = 21,
                    ["Tauren"] = 25,
                    ["Goblin"] = 17,
                    ["Blood Elf"] = 17,
                    ["Undead"] = 19
                   }
baseWarriorStamina = {                                 --Base Warrior Stamina Table
                    ["Human"] = 20,
                    ["Dwarf"] = 23,
                    ["Draenei"] = 19,
                    ["Gnome"] = 19,
                    ["Night Elf"] = 19,
                    ["Worgen"] = 20,
                    ["Pandaren"] = 21,
                    ["Orc"] = 22,
                    ["Troll"] = 21,
                    ["Tauren"] = 22,
                    ["Goblin"] = 20,
                    ["Blood Elf"] = 18,
                    ["Undead"] = 21
                   } ]]

local stam = 0
local mastery = 0
local stats = 0
local base_Block = 13
local base_Dodge = 5.01
local base_Parry = 3
local base_Mastery = 0
local base_Strength = 0
local base_Stamina = 0
local mastery_Rating = GetCombatRating(26)
local dodge_Rating = GetCombatRating(3)
local parry_Rating = GetCombatRating(4)
local current_Strength = UnitStat("player", 1)
local current_Parry = GetParryChance()
local current_Dodge = GetDodgeChance()
local current_Block = GetBlockChance()
local dodge_Scalar = 885
local parry_Scalar = 885
local mastery_Scalar = 0
local block_Scalar = 0
local strength_Scalar = 951.158596
local l, armor, o, p, q = UnitArmor("player")
local stam_Flask
local str_Flask
local c_Dodge = 0
local c_Parry = 237.186
local c_Block = 150.3759
local k = 0


--TruBlock Block and CTC Calculation prototype

if select(2, UnitClass("player")) ~= "PALADIN" and select(2, UnitClass("player")) ~= "WARRIOR"then             --special thanks to Celestial Fury for class based disabling function

   UIErrorsFrame:AddMessage("TruBlock only supports Warriors and Paladins, addon disabled")

   return DisableAddOn("TruBlock")

end

function formatNumber(num2, pow)   --Returns 'num' formatted to 'pow' decimal places, no rounding occurs

	return math.floor(num2 * math.pow(10, pow))/math.pow(10, pow)

end

function round(num1, decPlaces)

	return math.floor(num1 * math.pow(10, decPlaces) + 0.5)/math.pow(10, decPlaces)

end

function missChance()   --Determines the characters base chance to be missed by Bosses

   local player, race = UnitRace("player")

   if race == "NightElf" then

      return 5

   else

      return 3

   end

end

function classCheck()             --Determines the Character's class to set how much block per Mastery Skill

   local name, class = UnitClass("player")

   if class == "PALADIN" then

      k = 0.886
      c_Dodge = 66.56744
      mastery_Scalar = 600
      block_Scalar = 1
      base_Mastery = 8

      base_Strength =  basePaladinStrength[UnitRace("player")]
      base_Stamina = basePaladinStamina[UnitRace("player")]

   elseif class == "WARRIOR" then

      k = 0.956
      c_Dodge = 90.6425
      mastery_Scalar = 272.72727
      block_Scalar = (.5/2.2)
      base_Mastery = 17.6

      --base_Strength =  baseWarriorStrength[UnitRace("player")]
      --base_Stamina = baseWarriorStamina[UnitRace("player")]

   end

end

function hasStats()
   if UnitBuff("player", "Blessing of Kings") or UnitBuff("player", "Mark of the Wild") or UnitBuff("player", "Embrace of the Shale Spider") or UnitBuff("player", "Legacy of the Emperor") then
      stats = 0
   else
      stats = 0.05
   end
end

function hasMastery()
   if UnitBuff("player", "Blessing of Might") or UnitBuff("player", "Grace of Air") or UnitBuff("player", "Roar of Courage") or UnitBuff("player", "Spirit Beast Blessing") then
      mastery = 0
   else
      mastery = 3000
   end
end

function hasStam()
   if UnitBuff("player", "Power Word: Fortitude") or UnitBuff("player", "Commanding Shout") or UnitBuff("player", "Blood Pact") or UnitBuff("player", "Qiraji Fortitude") then
      stam = 0
   else
      stam = .1
   end
end

function checkBuffs()
   hasStats()
   hasStam()
   hasMastery()
end

function trueBlockChance()

   hit_Chance = 102.4 - (missChance() + total_Parry + total_Dodge)

   block_Roll = total_Block/100    --Determine the Block chance of the second roll after Diminishing Returns

   true_Block = hit_Chance * block_Roll --Calculate the chance to block based on a single roll system

   return true_Block

end

function getBuffedHealth()                         --Returns the raid buffed Health of the Character

   local health = UnitHealthMax("player")
   local stamina = UnitStat("player", 3)

   local base_Health = health - ((stamina - base_Stamina) * 14 + base_Stamina)

   local buffed_Health = (base_Health + ((stamina --[[+ (stam_Food + stam_Flask)]] * 1.2075) * (1 + stam) - base_Stamina) * 14)

   return buffed_Health

end

function getArmorDR() --Returns the damage reduction of armor against a Boss Level target

   armor_Redux = (armor/(armor + 4037.5 * 93 - 317117.5)) * 100

   return formatNumber(armor_Redux, 2)

end

function getDodgeDR()

   local raw_Dodge = --[[((((current_Agility + agiFood + agiFlask) * (1 + stats)) - base_Agility)/agility_Scalar)]]((dodge_Rating --[[+ dodge_Food]]) / dodge_Scalar)

   diminished_Dodge = math.pow((1/c_Dodge + k/raw_Dodge), -1)

   dodge_DR = 100 - ((diminished_Dodge) / (raw_Dodge)) * 100

   total_Dodge = diminished_Dodge + base_Dodge --[[+ (base_Agility / agility_Scalar)]]

   return formatNumber(dodge_DR, 2)

end

function getBlockDR()

   classCheck()

   local raw_Block = (((mastery_Rating + mastery --[[+ mastery_Food]]) / mastery_Scalar) + base_Mastery) * block_Scalar

   diminished_Block = math.pow((1/c_Block) + (k/(floor((raw_Block * 128) + 0.5)/128)), -1)

   block_DR = 100 - ((diminished_Block) / (raw_Block)) * 100

   total_Block = diminished_Block + base_Block

   return formatNumber(block_DR, 2)

end

function trueCBlockChance()

   classCheck()

   local crit_Block = (((mastery_Rating + mastery --[[+ mastery_Food]]) / mastery_Scalar) + base_Mastery)/100

   true_CBLock = trueBlockchance() * crit_Block

   return formatNumber(true_CBlock, 2)

end

function getParryDR()

   local raw_Parry = (parry_Rating --[[+ parry_Food]] / parry_Scalar + (current_Strength --[[+ strength_Food + str_Flask ]]* (1 + stats) - base_Strength)) / strength_Scalar

   diminished_Parry = math.pow((1/c_Parry + k/raw_Parry), -1)

   parry_DR = 100 - ((diminished_Parry) / (raw_Parry)) * 100

   total_Parry = diminished_Parry + base_Parry + (base_Strength / strength_Scalar)

   return formatNumber(parry_DR, 2)

end

function avoidanceRatio()

   parry_Required = base_Parry + (c_Parry / c_Dodge) * diminished_Dodge

   return formatNumber(parry_Required, 2)

end

function combatTableCoverage()


   total_CTC = diminished_Dodge + diminished_Parry + trueBlockChance() + missChance()        -- Sum of all diminished defense stats

   return formatNumber(total_CTC, 2)

end

function displayTruBlock()          -- Prints all the CTC and Block data to the chat window

   classCheck()
   checkBuffs()
   getDodgeDR()
   getParryDR()
   getBlockDR()

   print("======================")
   print("==  TRUBLOCK v. 2.3 ==")
   print("======================")
   print("")
   print("My Raid Buffed Stats are:")
   print("")
   print(formatNumber(getBuffedHealth(),2).." Health.")
   print(formatNumber(armor,2).." Armor, a Boss damage reduction of "..getArmorDR().."%.")
   print(formatNumber(total_Dodge,2).."% Dodge with "..getDodgeDR().."% DR.")
   print(formatNumber(total_Parry,2).."% Parry with "..getParryDR().."% DR.")
   print("Parry required for DR equality: "..avoidanceRatio().."%.")
   print(formatNumber(total_Block, 2).."% Block with "..getBlockDR().."% DR.")

   local name, class = UnitClass("player")

   if class == "WARRIOR" then

      print("My True Block Chance is: "..formatNumber(trueBlockChance() - trueCBlockChance(), 2).."%.")
      print("my True Crit Block Chance is: "..formatNumber(trueCBlockChance(), 2).."%.")

   else

      print("My True Block Chance is: "..formatNumber(trueBlockChance(), 2).."%.")

   end

   print("My True 'CTC' is: "..combatTableCoverage().."%.")
   print("My chance to be hit by a Boss Attack is: "..formatNumber((102.4 - combatTableCoverage()), 2).."%.")
   print("")
   print("======================")
   print("======================")

end

SLASH_TRUBLOCK1 = "/tb"                -- Slash Commands for TankForge
SLASH_TRUBLOCK2 = "/trublock"

function SlashCmdList.TRUBLOCK(msg, editbox)         -- The handler for the In Game slash command

   displayTruBlock()

end

collectgarbage("collect")